/*
 * Copyright (C) 2012 - 2016 Texas Instruments Incorporated - http://www.ti.com/ 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 *  modification, are permitted provided that the following conditions 
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the   
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

// MSP_FET430UIF_SetupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MSP430_FET.h"
#include "MSP_FET430UIF_Setup.h"
#include "MSP_FET430UIF_SetupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Notify callback function for MSP430.dll PostMessages

static void MY_MSP430_FET_NOTIFY_FUNC(
					uint32_t MsgId,
					uint32_t wParam,
					uint32_t lParam,
					int32_t clientHandle)
{
	if(clientHandle)
	{
		((CMSP_FET430UIF_SetupDlg*)clientHandle)->HandleFET430Callbacks(MsgId, wParam, lParam);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_Disclaimer;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_Disclaimer = _T("All software and related documentation is provided \"AS IS\" and without warranty or support of any kind and Texas Instruments expressly disclaims all other warranties, express or implied, including, but not limited to, the implied warranties of merchantability and fitness for a particular purpose. Under no circumstances shall Texas Instruments be liable for any incidental, special or consequential damages that result from the use or inability to use the software or related documentation, even if Texas Instruments has been advised of the liability.");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_DISCLAIMER, m_Disclaimer);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMSP_FET430UIF_SetupDlg dialog

CMSP_FET430UIF_SetupDlg::CMSP_FET430UIF_SetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMSP_FET430UIF_SetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMSP_FET430UIF_SetupDlg)
	m_strDllVersion = _T("");
	m_strPercent = _T("");
	m_strStatus = _T("");
	m_strFwVersion = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMSP_FET430UIF_SetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMSP_FET430UIF_SetupDlg)
	DDX_Control(pDX, IDC_BL_PROGRESS, m_ctrlBlProgress);
	DDX_Text(pDX, IDC_STATIC_DLLVERSION, m_strDllVersion);
	DDX_Text(pDX, IDC_STATIC_PERCENT, m_strPercent);
	DDX_Text(pDX, IDC_STATIC_STATUS, m_strStatus);
	DDX_Text(pDX, IDC_STATIC_FWVERSION, m_strFwVersion);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMSP_FET430UIF_SetupDlg, CDialog)
	//{{AFX_MSG_MAP(CMSP_FET430UIF_SetupDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_UPDATE, OnUpdate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMSP_FET430UIF_SetupDlg message handlers

BOOL CMSP_FET430UIF_SetupDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	{
		STATUS_T Ret         = STATUS_ERROR;
		int32_t  DllVersion	 = 0;
		int32_t  UsbVersion  = 0;
		LONG     ErrorNumber = NO_ERR;

		// try to open USB port to get Firmware version number
		if((Ret = MSP430_Initialize("TIUSB",&DllVersion)) == STATUS_OK)
		{ // get firmware version number & close port
			Ret = MSP430_FET_GetFwVersion(&UsbVersion);
			Ret = MSP430_Close(TRUE);
			m_strDllVersion = FormatVersionNumber(DllVersion);
			m_strFwVersion = FormatVersionNumber(UsbVersion);
		}
		else
		{
			if((ErrorNumber = MSP430_Error_Number()) == USB_FET_BSL_ACTIVE_ERR)
			{
				m_strFwVersion = "Erased!";
			}
			else
			{
				m_strFwVersion = MSP430_Error_String(ErrorNumber);
			}
		}

		m_strPercent = "0";
		UpdateData(FALSE);
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMSP_FET430UIF_SetupDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMSP_FET430UIF_SetupDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMSP_FET430UIF_SetupDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMSP_FET430UIF_SetupDlg::OnUpdate() 
{
	// Firmware Update
	STATUS_T Ret = STATUS_ERROR;
	LONG RetErrorNumber = NO_ERR;
	int32_t version = 0;

	m_ctrlBlProgress.SetRange(0,100);
	m_ctrlBlProgress.SetPos(0);

	if((Ret = MSP430_Initialize("TIUSB",&version)) == STATUS_OK)
	{

		if((Ret = MSP430_FET_FwUpdate(NULL,MY_MSP430_FET_NOTIFY_FUNC,(int32_t)this)) == STATUS_OK)
		{
			m_strPercent = "100";
			m_ctrlBlProgress.SetPos(100);
			m_strDllVersion = m_strDllVersion;
		}
		else
		{
			RetErrorNumber = MSP430_Error_Number();
			m_strStatus = MSP430_Error_String(RetErrorNumber);
		}
		// End of Update
	}

	UpdateData(FALSE);
}

void CMSP_FET430UIF_SetupDlg::HandleFET430Callbacks(unsigned int MsgId, unsigned long wParam, unsigned long lParam)
{
	LONG RetErrorNumber = NO_ERR;

	switch(MsgId)
	{	
		case BL_DATA_BLOCK_PROGRAMMED:
			if(wParam > 100) wParam = 100;
			m_ctrlBlProgress.SetPos(wParam);
			m_strPercent.Format("%d",wParam);
			break;
		case BL_UPDATE_ERROR:
			GetDlgItem(IDC_UPDATE)->EnableWindow(TRUE);
			RetErrorNumber = MSP430_Error_Number();
			m_strStatus = MSP430_Error_String(RetErrorNumber);
			break;
		case BL_WAIT_FOR_TIMEOUT:
			m_strStatus = "Wait for Bootloader to timeout (ca. 10s)...";
			break;
		case BL_INIT:
			GetDlgItem(IDC_UPDATE)->EnableWindow(FALSE);
			m_strStatus = "Initializing Bootloader...";
			break;
		case BL_ERASE_INT_VECTORS:
			m_strStatus = "Erasing Interrupt Vectors...";
			break;
		case BL_ERASE_FIRMWARE:
			m_strStatus = "Erasing Firmware...";
			break;
		case BL_PROGRAM_FIRMWARE:
			m_strStatus = "Programming New Firmware...";
			break;
		case BL_EXIT:
			m_strStatus = "Finishing...";
			break;
		case BL_UPDATE_DONE:
			m_strStatus = "Update Complete.";
			GetDlgItem(IDC_UPDATE)->EnableWindow(TRUE);
			break;
	}
	UpdateData(FALSE);
}


CString CMSP_FET430UIF_SetupDlg::FormatVersionNumber(LONG version)
{
   CString tmp;

   tmp.Format("%d",version);
   tmp.Insert(1,".");
   tmp.Insert(4,".");
   tmp.Insert(7,".");

   return tmp;
}

void CMSP_FET430UIF_SetupDlg::PerformFwUpdate()
{
    // Firmware Update
	m_ctrlBlProgress.SetRange(0,100);
	m_ctrlBlProgress.SetPos(0);

	if(MSP430_FET_FwUpdate(NULL,MY_MSP430_FET_NOTIFY_FUNC,(int32_t)this) == STATUS_OK)
	{
		m_strPercent = "100";
		m_ctrlBlProgress.SetPos(100);
	}
	// End of Update
}
