// PreinstalCDC.cpp : Defines the entry point for the application.
//
// Preinstallator for 430CDC.inf
// This applicatino is only demonstration how to use SetupCopyOEMInf().
// For end-installator it can be modified
// or the function SetupCopyOEMInf() can be used directly in the installation script.
// This application should be started before eZ430-RF plugged-in into USB port.
// The application pre-istalls the INF and CAT files for Windows.
// The 430CDC.inf and 430CDC.cat should be placed in the same directory with PreinstallCDC.exe
//
// Date: 2008-02-07
// Author: Rostyslav Stolyar
// Texas Intsruments
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
// EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
// OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
// OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#include "stdafx.h"
#include "windows.h"
#include "Setupapi.h"
#include <direct.h>

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
    //get current directory
    char pathbuffer[MAX_PATH];
    if (_getcwd(pathbuffer, MAX_PATH) == NULL)
    {
        MessageBox(NULL, "Can not get working directory", "Error", MB_OK);
        return -1;
    }

    //add "430CDC.inf" to the path...
    strcat(pathbuffer, "\\430CDC.inf");

	//This function pre-installs INF. For more info see MSDN.
    BOOLEAN status = SetupCopyOEMInf(
        pathbuffer,
        NULL,
        SPOST_PATH,
        SP_COPY_NEWER,
        NULL,
        0,
        NULL,
        NULL
    );

    if (!status)
    {
        TCHAR szBuf[250];
        LPVOID lpMsgBuf;
        DWORD dw = GetLastError();

        FormatMessage(
            FORMAT_MESSAGE_ALLOCATE_BUFFER |
            FORMAT_MESSAGE_FROM_SYSTEM,
            NULL,
            dw,
            MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
            (LPTSTR) &lpMsgBuf,
            0, NULL );

        wsprintf(szBuf, "Installation of 430CDC.inf failed with error: %s",
             (char*)lpMsgBuf);
        MessageBox(NULL, szBuf, "Error", MB_OK);

        LocalFree(lpMsgBuf);
        return -1;
    }
    MessageBox(NULL, "Success!\nCDC430.inf installed.", "Status", MB_OK);
    return 0;
}

